# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define reltag _redhat_2
%define namedreltag -redhat-2
%global namedversion %{version}%{?namedreltag}

%define section free

%bcond_without mead
%if %with mead
%bcond_with repolib
%else
%bcond_without repolib
%endif

%define maven_version 20110809-redhat-2

Name:           sun-txw2
Version:        20110809
Release:        6%{?reltag}%{?dist}.4
Epoch:          0
Summary:        Typed XML writer
License:        CDDL
Group:          Development/Java

%if %with mead
Source100: com.sun.xml.txw2-txw2-project-20110809-redhat-2-sources.zip
Source101: com.sun.xml.txw2-txw2-project-20110809-redhat-2-patches.zip
Source102: txw2-project-20110809-redhat-2.pom
Source103: txw2-20110809-redhat-2-sources.jar
Source104: txw2-20110809-redhat-2-javadoc.jar
Source105: txw2-20110809-redhat-2.pom
Source106: txw2-20110809-redhat-2.jar
Source107: txwc2-20110809-redhat-2-javadoc.jar
Source108: txwc2-20110809-redhat-2.jar
Source109: txwc2-20110809-redhat-2.pom
Source110: txwc2-20110809-redhat-2-sources.jar
%endif

URL:            https://txw.dev.java.net/
%if %without mead
%if 0
rm -rf sun-txw2-20110809 sun-txw2-20110809.tar.bz2
svn export https://svn.java.net/svn/jaxb~version2/tags/txw2-project-20110809 sun-txw2-20110809 && tar cjf sun-txw2-20110809.tar.bz2 sun-txw2-20110809
%endif
Source0:        sun-txw2-20110809.tar.bz2
Patch0:         txw2-pom.patch
Patch1:         txw2-args4j.patch
%endif
Provides:       txw2 = %{epoch}:%{version}-%{release}
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
%if %without mead
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  jboss-parent
BuildRequires:  junit4 >= 0:4.8.1
BuildRequires:  jvnet-parent >= 0:1
BuildRequires:  maven2
BuildRequires:  maven2-plugin-ant
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-surefire
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  oss-parent
BuildRequires:  ant >= 0:1.8.1
BuildRequires:  args4j >= 0:1.0
BuildRequires:  codemodel >= 0:2.4
BuildRequires:  relaxngDatatype >= 0:2002.04.14
BuildRequires:  rngom >= 0:201007
BuildRequires:  xsom >= 0:20110809
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
TXW is a library that allows you to write XML documents. 
TXW has the following benefits compared to the other XML 
writer libraries:
1. TXW gets rid of string constants for element/attribute 
   names. Those constant names become method names.
2. TXW manages the namespace binding for you. It automatically 
   declares the necessary URIs.
3. TXW allows you to use typed values (such as ints, booleans, 
   or QNames), eliminating cumbersome String.valueOf or the
   use of toString methods.
4. TXW allows you to stream the writing process (IOW, it starts 
   generating pieces as soon as data is available), while at
   the same time allowing you to work out-of-order when you need to.
5. TXW is very small (<50KB)
6. TXW allows you to control various low-level aspects of XML
   writing, such as comments, PIs, and prefix assignments. 

%package compiler
Summary:        Compiler from txw2
Group:          Development/Libraries/Java

Provides:       txwc2 = %{epoch}:%{version}-%{release}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       ant >= 0:1.8.1
Requires:       args4j >= 0:1.0
Requires:       relaxngDatatype >= 0:2002.04.14
Requires:       rngom >= 0:201007
Requires:       codemodel >= 0:2.4
Requires:       xsom >= 0:20110809

%description compiler
%{summary}.

%package javadoc
Summary:        Javadoc for txw2
Group:          Development/Documentation

Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java


%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%if %without mead
%setup -q
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%endif

%build
%if %without mead
export LC_ALL=en_US.UTF8
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export ALT_DEPLOYMENT_REPOSITORY=oss-releases::default::file:`pwd`/maven2-brew
export MAVEN_OPTS="-Xms1g -Xmx1g -XX:MaxPermSize=512M -Dproject.build.sourceEncoding=UTF8"
%{_bindir}/mvn-jpp -e -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DaltDeploymentRepository=${ALT_DEPLOYMENT_REPOSITORY} deploy javadoc:aggregate
%define prevversion 201103-redhat-2
for d in `%{_bindir}/find maven2-brew -type d -name %{prevversion}`; do
    %{__mv} ${d}/* `/bin/echo ${d} | %{__sed} -e 's|%{prevversion}|%{namedversion}|;'`/
    %{__rm} -r ${d}/
done
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/xml/txw2/txw2/%{namedversion}/txw2-%{namedversion}-sources.jar %{buildroot}%{_javadir}/txw2-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/xml/txw2/txw2/%{namedversion}/txw2-%{namedversion}.jar %{buildroot}%{_javadir}/txw2-%{namedversion}.jar
%{__cp} -p maven2-brew/com/sun/xml/txw2/txwc2/%{namedversion}/txwc2-%{namedversion}-sources.jar %{buildroot}%{_javadir}/txwc2-%{namedversion}-sources.jar
%{__cp} -p maven2-brew/com/sun/xml/txw2/txwc2/%{namedversion}/txwc2-%{namedversion}.jar %{buildroot}%{_javadir}/txwc2-%{namedversion}.jar
%else
%{__cp} -p %{_sourcedir}/txw2-%{namedversion}.jar %{buildroot}%{_javadir}/
%{__cp} -p %{_sourcedir}/txw2-%{namedversion}-sources.jar %{buildroot}%{_javadir}/
%{__cp} -p %{_sourcedir}/txwc2-%{namedversion}.jar %{buildroot}%{_javadir}/
%{__cp} -p %{_sourcedir}/txwc2-%{namedversion}-sources.jar %{buildroot}%{_javadir}/
%endif
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%if %without mead
%{__cp} -p maven2-brew/com/sun/xml/txw2/txw2-project/%{namedversion}/txw2-project-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txw2-project.pom
%{__cp} -p maven2-brew/com/sun/xml/txw2/txw2/%{namedversion}/txw2-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txw2.pom
%{__cp} -p maven2-brew/com/sun/xml/txw2/txwc2/%{namedversion}/txwc2-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txwc2.pom
%else
%{__cp} -p %{_sourcedir}/txw2-project-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txw2-project.pom
%{__cp} -p %{_sourcedir}/txw2-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txw2.pom
%{__cp} -p %{_sourcedir}/txwc2-%{namedversion}.pom %{buildroot}%{_mavenpomdir}/JPP-txwc2.pom
%endif

# depmaps
%add_to_maven_depmap com.sun.xml.txw2 txw2-project %{namedversion} JPP txw2-project
%add_to_maven_depmap com.sun.xml.txw2 txw2 %{namedversion} JPP txw2
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/txw2
%add_to_maven_depmap com.sun.xml.txw2 txwc2 %{namedversion} JPP txwc2
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/txwc2

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/txw2-%{namedversion}
%if %without mead
%{__cp} -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/txw2-%{namedversion}
%else
%{__unzip} -qq %{_sourcedir}/txw2-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/txw2-%{namedversion}/txw2
rm -rf %{buildroot}%{_javadocdir}/txw2-%{namedversion}/txw2/META-INF
%{__unzip} -qq %{_sourcedir}/txwc2-%{namedversion}-javadoc.jar -d %{buildroot}%{_javadocdir}/txw2-%{namedversion}/txwc2
rm -rf %{buildroot}%{_javadocdir}/txw2-%{namedversion}/txwc2/META-INF
%endif
%{__ln_s} txw2-%{namedversion} %{buildroot}%{_javadocdir}/txw2

# repolib
%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%endif

# release txt files
%{__unzip} -qq %{_sourcedir}/com.sun.xml.txw2-txw2-project-%{namedversion}-sources.zip 
%{__cp} -p txw2-project/*.txt ./
%{__rm} -rf txw2-project

%clean
%{__rm} -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc license.txt
%{_javadir}*/txw2-%{namedversion}-sources.jar
%{_javadir}*/txw2-sources.jar
%{_javadir}*/txw2-%{namedversion}.jar
%{_javadir}*/txw2.jar
%{_mavenpomdir}/JPP-txw2-project.pom
%{_mavenpomdir}/JPP-txw2.pom
%{_mavendepmapfragdir}/txw2

%files compiler
%defattr(0644,root,root,0755)
%{_javadir}*/txwc2-%{namedversion}-sources.jar
%{_javadir}*/txwc2-sources.jar
%{_javadir}*/txwc2-%{namedversion}.jar
%{_javadir}*/txwc2.jar
%{_mavenpomdir}/JPP-txwc2.pom
%{_mavendepmapfragdir}/txwc2

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/txw2-%{namedversion}
%{_javadocdir}/txw2

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Sep 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-6_redhat_2.4
- Rebuild for RHEL-5

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-5_redhat_2.4
- Rebuild unsigned

* Thu Aug 09 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-5_redhat_2.3
- Rebuild unsigned

* Mon Jul 30 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-5_redhat_1.2
- Rebuild unsigned

* Wed Jul 25 2012 Fernando Nasser <fnasser@redhat.com> - 0:20110809-5_redhat_1.1
- Rebuild using cache signing

* Tue Jul 24 2012 Hui Wang <huwang@redhat.com> 0:20110809-5_redhat_1
- Rebuild

* Tue Jul 24 2012 Hui Wang <huwang@redhat.com> 0:20110809-4_redhat_1
- First mead build

* Sat May 05 2012 David Walluck <dwalluck@redhat.com> 0:20110809-3
- use com.github.relaxng not relaxngDatatype for groupId
- resolves JBPAPP-8931

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:20110809-2
- fix rngom version

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:20110809-1
- 20110809
- recreate pom patch
- fix macro in change log
- add BuildRequires: jvnet-parent
- version some BuildRequires

* Tue May 01 2012 David Walluck <dwalluck@redhat.com> 0:201103-1
- run vman aginst pom (removes hardcoded versions and repository)
- manually remove -SNAPSHOT and stax-api:stax-api from pom
- resolves JBPAPP-8871

* Fri Feb 24 2012 David Walluck <dwalluck@redhat.com> 0:201103-0.1
- 201103

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 0.1-0.20070624.2
- Auto rebuild for JPackage 5 in mock

* Tue Mar 11 2008 Ralph Apel <r.apel at r-apel.de> 0:0.1-0.20070624.1jpp
- First release
